/*
 *  MPEG-1 Real Time Encoder
 *
 *  Copyright (C) 1999-2000 Michael H. Schimek
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* $Id: systems.h,v 1.1 2000/06/06 08:26:28 michael Exp $ */

extern pthread_mutex_t		mux_mutex;
extern pthread_cond_t		mux_cond;
extern int			bytes_out;
extern unsigned char *		mux_buffer;
extern double			system_idle;

extern double			get_idle(void);
extern void			stream_output(fifo *fifo);
extern void			mpeg1_system_run_in(void);
extern void *			mpeg1_system_mux(void *unused);

static inline void
output(void *s, size_t n)
{
	ssize_t r;

	bytes_out += n;

	while (n > 0)
	{
		r = write(STDOUT_FILENO, s, n);

		if (r < 0 && errno == EINTR)
			continue;

		ASSERT("write", r >= 0);

		(char *) s += r;
		n -= r;
	}
}
