/*
 *  MPEG-1 Real Time Encoder
 *
 *  Copyright (C) 2000 Michael H. Schimek
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* $Id: tkme.c,v 1.2 2000/06/08 18:53:34 michael Exp $ */

#include "tkme.h"

Tcl_Interp *my_interp;

void
evals(Tcl_Interp *interp, char *template, ...)
{
	char buffer[256];
	va_list ap;

	va_start(ap, template);
	vsprintf(buffer, template, ap);
	va_end(ap);                                                                                
	Tcl_Eval(interp, buffer);
}

extern int video_bit_rate;
extern int video_do_reset;
extern double gbits;
extern int force_drop_rate;
extern int p_inter_bias;
extern int b_inter_bias;
extern double frame_rate;
extern int quant_max;

int
set_video_bit_rate(ClientData clientdata, Tcl_Interp *interp, int argc, char *argv[])
{
	int i;

	if ((i = (int)(strtod(argv[1], NULL) * 1E6)) != video_bit_rate) {
		video_bit_rate = i;
		video_do_reset = 1;
	}
	interp->result = "";
	return TCL_OK;
}

int
set_force_drop_rate(ClientData clientdata, Tcl_Interp *interp, int argc, char *argv[])
{
	force_drop_rate = strtol(argv[1], NULL, 0);
	interp->result = "";
	return TCL_OK;
}

int
set_inter_bias(ClientData clientdata, Tcl_Interp *interp, int argc, char *argv[])
{
	if (!strcmp(argv[0], "set_p_inter_bias"))
		p_inter_bias = strtol(argv[1], NULL, 0) * 65536;
	else if (!strcmp(argv[0], "set_quant_max")) {
		quant_max = strtol(argv[1], NULL, 0);
		video_do_reset = 1;
	} else
		b_inter_bias = strtol(argv[1], NULL, 0) * 65536;
	interp->result = "";
	return TCL_OK;
}

void
status_update(ClientData clientdata)
{

	evals(my_interp, ".v_vbr configure -text %2.2f", gbits / 1E6);

	Tcl_CreateTimerHandler(250, status_update, (ClientData) NULL);
}

int
set_frame_rate(ClientData clientdata, Tcl_Interp *interp, int argc, char *argv[])
{
	double n;

	if ((n = strtod(argv[1], NULL)) != frame_rate) {
		frame_rate = n;
		video_do_reset = 1;
	}
	interp->result = "";
	return TCL_OK;
}
